## _*_ coding:UTF-8 _*_
## import os
## import os.path as osp
## import urllib.request
## import urllib.parse
import json
import requests

class RestApi:
    def __init__(self):
        self.url = 'http://127.0.0.1:12345/'
        self.headers = {'content-type': 'application/json', 'charset': 'utf-8'}
        self.exchange = 'HKEX'

    def action(self, side, code, price, num, orderId):
        params = {"side": side,
                  "symbol": code,
                  "exchange": self.exchange,
                  "type": "Limit",
                  "price": price,
                  "qty": num,
                  'clord_id': orderId}
        url = self.url + 'order/insert'

        res = requests.post(url=url, data=json.dumps(params), headers=self.headers)
        print(res.text)

    def queryPosition(self):
        params = {"exchange": self.exchange}
        url = self.url + 'query/position'
        res = requests.post(url=url, data=json.dumps(params), headers=self.headers)
        print(res.text)
        return res.text

    def queryAccount(self):
        params = {"exchange": self.exchange}
        url = self.url + 'query/account'
        res = requests.post(url=url, data=json.dumps(params), headers=self.headers)
        print(res.text)

    def cancel(self, order_id):
        params = {"order_id": order_id}
        url = self.url + 'order/cancel'
        res = requests.post(url=url, data=json.dumps(params), headers=self.headers)
        print(res.text)

    def queryOrders(self):
        params = {}
        # params = {"status": "CANCELED"}
        url = self.url + 'query/order'
        res = requests.post(url=url, data=json.dumps(params), headers=self.headers)
        # print(res.text)
        # print(eval(res.text))

        j = json.loads(res.text)
        # print(len(j['orders']))
        # print(type(j['orders']))

        # print(j['orders'][1]['status'])
        # print(type(j['orders'][1]))
        # print(type(j['orders'][1]['status']))

        order_non_canceled_dict = {}

        for iii in range(len(j['orders'])):
            # print(iii)
            # if j['orders'][iii]['open_close'] == 'OPEN':
            if j['orders'][iii]['status'] != 'CANCELED':
                # print(j['orders'][iii])
                i_tmp = 0
                # print(str(len(order_non_canceled_dict)))
                order_non_canceled_dict[str(len(order_non_canceled_dict)+1)] = j['orders'][iii]['order_id']

                for item, value in j['orders'][iii].items():
                    i_tmp += 1

                    print('========', len(order_non_canceled_dict), '========', i_tmp, '.', item, ':', value)

                print('\n')
                # print(order_non_canceled_dict)
                # print(order_non_canceled_dict['1'])
                # print('\n')

        return order_non_canceled_dict


def main():
    rest_api = RestApi()
    y = 1
    while y > 0:
        z = input('\nInput The Operation No.:\n' +
                  '1 to action Order;\n' +
                  '2 to query Position;\n'
                  '3 to query Orders and to cancel Order;\n' +
                  '4 to cancel Order——Base on Operation 3.\n' +
                  '0 to quit;\n' +
                  '=====Operation Code：')

        if z == '':
            pass
        else:
            x = eval(z)
            # print("\n\n======================= Trade starts =============================")
            if x == 0:
                y = x
                pass
            elif x == 1:
                print("\n======1 action buy====")
                rest_api.action(side='BUY', code='06862', price=59.5, num=2000, orderId=16)
                y = x
            elif x == 2:
                print("\n======2 queryPosition ====")
                rest_api.queryPosition()
                y = x
            elif x == 3:
                print("\n======3 queryOrders ====,")
                order_non_canceled_dict = rest_api.queryOrders()
                print(order_non_canceled_dict, '\n')

                if len(order_non_canceled_dict) > 0:
                    order_id = input('Please Input The Order Sequence No.:')
                    for key in order_non_canceled_dict.keys():
                        if order_id != '' and order_id == key:
                            rest_api.cancel(order_non_canceled_dict[order_id])
                y = x
            elif x == 4:
                print("\n======4 cancelOrder ===")
                order_id = input('Base on Operation 3, Please Input The Order Id:')
                if order_id != '':
                    rest_api.cancel(order_id)
                y = x
            elif x == 5:
                print("\n======5 action sell ====")
                rest_api.action('SELL', '01053', 1.470, 8000, 0)
                y = x
            elif x == 6:
                pass
                y = x
                # rest_api.queryAccount()
            elif x == 100:
                print("=====\n")
                pass
                y = 1

            # print("====================================End===================================================")


if __name__ == "__main__":
    main()
